﻿<?php

/***************************************************************************************************
Webservices V3 - pack version 03- Metodo cancelar

Este programa utiliza as funções contidas no arquivo WStoolsV3 fornecido no pacote Webservice Standard

Este programa permite chamar o metodo criar definido no wsdl em:  https://systempay.cyberpluspaiement.com/vads-ws/v3?wsdl'.


Este método permite cancelar definitivamente uma transação, ainda não capturada, com um dos seguintes estados:
•	Para validar				-> status => 1
•	Para validar e autorizar	-> status => 3
•	Espera						-> status => 10
•	Espera automatico			-> status => 5
•	Espera de captura			-> status => 4


PARÂMETRO DE ENTRADO DO MÉTODO

•	$params é uma tabela de parâmetros:

	- 	shopId => Código de identificação da loja, esta informação você obtem em seu backoffice do PayZEN em Configuração >> Lojas >> Sua loja >> Aba Configuração.'

	-	transmissionDate => Data da apresentação da transação definido na criação do pagamento.
		É obrigatório utilizar o formato DD-MM-AAAA para a data
	
	-   transactionId => Identificação da transação definido na criação do pagamento. Este código será a identificação nem sua ferramenta de gestão do PayZEN, o backoffice.
	
	- 	sequenceNb => il s'agit du numéro de séquence de la transaction. Dans le cas d'un paiement unique il est fixé à 1.
		Dans le cas d'un paiement en plusieurs fois il est fixé à 2 s'il s'agit de la 2eme échéance de la transaction , fixé à 3 s'il s'agit
		de la 3 eme echéance etc ...

	-	ctxMode => Este parâmetro define o ambiente de teste ou produção. Para o ambiente de teste utilize o valor TEST e para o de produção utilize o valor PRODUCTION.
		
	-	comment => Utilizado para eventual comentário que será registrado no backoffice do PayZEN

• $key corresponde ao certificado . Este valor é diferente para o ambiente de produto e de testes .
Você encontra o certificado no backoffice do PayZEN em Configuração >> Lojas >> Sua loja >> Aba Certificados.

***************************************************************************************************/
// Declaração dos parâmetros de entrada no método getInfo
$param=array();
$param['shopId']='94956185';
$param['transmissionDate']='22-03-2012';
$param['transactionId']='165145';
$param['sequenceNb']='1';
$param['ctxMode']='PRODUCTION';
$param['comment']='Test webservice';

require_once './classes/wsToolV3.php';
//Déclaração de um objeto
$WS= new WS_API();

// Déclaração do certificado, atributo do objeto WS

$WS->key='9874548989598030';  // Atenção: Este parametro possui valores diferentes para o ambiente de TESTE e PRODUÇÃO

// Chamada do método e retorno da respota.

$response=$WS->cancel($param); //  Esta função da classe WS_API retorna um objeto do tipo transaction Info

// Analise da assinatura obtido no retorno.
$control_sign=array();
$control_sign=$WS->getResponse('cancel',$response);

	if ($control_sign['result']=='1')
		{
			
			//Se a assinatura for válida, você pode considerar que os dados retornados são seguros.
		
			//Exibição da resposta
			echo $control_sign['message'].'</br>';
			echo 'Você pode considerar os dados técnicos listados abaixo como seguro </br>';
			echo '<div style="border:1px solid black;;width:400px;margin-left:auto;margin-right:auto;margin-top:25px"></br>';
			echo 'ELEMENTOS TÉCNICOS RETORNADOS';
			echo '</br></br>';
			print_r ('<table ');
				foreach ($response as $name => $value)
				{
				echo ('<tr><td style="font-size:12px;text-align:left">'.$name .'</td><td style="font-size:12px;text-align:left">'.$value.'</td></tr>');
    			}
			print_r('</table>');
			echo '</div>';
			echo '</br></br>';
		
		}
	else
		{
			//Se a assinatura não for válida, você pode considerar que os dados retornados não são seguros, risco de fraude.
		
			// Exibição da resposta
			echo $control_sign['message'].'</br>';
			echo 'Os dados listados abaixo não são seguro - Risco de fraude</br>';
			echo '<div style="border:1px solid black;;width:400px;margin-left:auto;margin-right:auto;margin-top:25px"></br>';
			echo 'ELEMENTOS TÉCNICOS RETORNADOS';
			echo '</br></br>';
			print_r ('<table ');
				foreach ($response as $name => $value)
				{
				echo ('<tr><td style="font-size:12px;text-align:left">'.$name .'</td><td style="font-size:12px;text-align:left">'.$value.'</td></tr>');
    			}
			print_r('</table>');
			echo '</div>';
			echo '</br></br>';
	
		}




?>