
<?PHP
/***************************************************************************************************
Webservices V3 - pack version 03- WS_API


Release Note:
version 2.1
Clculo da correo das datas a ter em conta os fusos horrios
em funo da classe getSignatureValue FieldDate

version 2.0
Alm dos tipos de resposta de gesto para o clculo da assinatura de retorno.
Integrao de todos os mtodos como uma funo.
Alm do tipo threeDsResult para gerenciar 3DS pagamentos.
Adicionando o mtodo modifyAndValidate


version 1.2
Corrigido a ordem dos campos no clculo da assinatura do mtodo de criao

version 1.1
Removido usar 'print_r' o comando em todas as funes.

Este arquivo contm um conjunto de funes usadas nas amostras de cdigo fornecido pelo
Lyra Network, no seguinte endereo https://www.payzen.com.br/html/code.html

***************************************************************************************************/

/* Classe Field: 
Todos os objetos 'simples' so de tipos campos, ormis os objetos do tipo 'Date' 
Cada objeto tem os seguintes atributos: 
		nom($name),
		valeur($value), 
		libell($label), 
		description($description), 
		format($type), 
		'indicateur de champ obligatoire'($required)
*/
class Field {

	var $name;
	var $value;
	var $label;
	var $description;
	var $type;
	var $required;
	
	/* Construtor de campos do tipo 'Field' */
	function Field($name, $label, $description, $type,$required) {
		$this->name =$name;
		$this->label =$label;
		$this->description =$description;
		$this->type =$type;
		$this->required =$required;
		
	}
	/* Esta funo define o valor de um objeto*/ 
	function setValue ($value) {
		if ($this->value!==''){
			$this->value = $value;
		}
		
	}
	/* Esta funo retorna o valor de um objeto */ 
	function getValue () {
		
		return $this->value;
	}
	/* Esta funo retornar o valor de um objeto quanto ao clculo da assinatura */ 
	function getSignatureValue () {
		return $this->value;
	}
}

/* Esta classe permite criar objetos do tipo 'Date', 
usando o construto da classe Field 
*/
class FieldDate extends Field {
	
	/* Esta funo converte o valor deu um objeto do type 'Date' em timestamp */
	function setValue ($value) {
		if($value!=null) {
			$this->value = strtotime($value);
		}
		else {$this->value = null;}
	}
	/* Esta funo formata o valor de um objeto do type 'Date' no format W3C */
	function getValue () {
		if($this->value==null) {
			return null;
		}
		return gmdate(DateTime::W3C,$this->value);
	}
	/* Esta funo formata o valor de um objeto do tipo 'Date' no formato yyyyMMdd para o calculo da assinatura */
	function getSignatureValue () {
		if($this->value==null) {
			return null;
		}
		return gmdate('Ymd',$this->value); // version 2.1 - Correo do calculo das datas considerando dois fusos horrios diferentes
	}

}

class threeDsResult extends Field {
	
	

	/* Esta funco fixa o valor de um objeto*/ 
	function setValue ($value) {
		if ($this->value!==''){
			$this->value = $value;
		}
		
	}
	/* Esta funo formata o valor de um objeto */ 
	function getValue () {
		
		return $this->value;
	}
	/* Esta funo formata o valor de um objeto quando se calcula o valor da assinatura*/ 
		
	function getSignatureValue () {
		if ($this->value != null){
			$raw_sign='';		
			foreach($this->value as $key=>$value) {

					$raw_sign .= $value . '+';
					
					
			}
			$raw_sign= substr($raw_sign,0, -1);
			return $raw_sign;
		}
		else
		$this->value=null;
	}
	
}

class WS_API {	

	/* Funo de atalho que permite criar um objeto do tipo date*/
	function _addFieldDate($name, $label=null, $description=null, $type='Date',$required=true) {
		$this->$name = new FieldDate($name, $label, $description, $type,$required);
	}
	/* Funo de atalho que permite criar um objeto*/
	function _addField($name, $label=null, $description=null, $type=null,$required=false) {
		$this->$name = new Field($name, $label, $description, $type,$required);
	}
	
	
	function _addFieldThreeDS($name, $label=null, $description=null, $type=null,$required=false) {
		$this->$name = new threeDsResult($name, $label, $description, $type,$required);
	}
	
	
function WS_API	() {
$wsdl='https://secure.payzen.com.br/vads-ws/v3?wsdl';
//$wsdl='https://brasildebug.xaphania.lyra-network.com/vads-ws/v3?wsdl';
try{

$this->client = new soapclient($wsdl,array('trace' =>1));
}catch(SoapFault $fault){
	print_r($fault->faultcode."-".$fault->faultstring);
	};


/* Dclarao dos objetos do tipo simples 
$name, $label=null, $description=null, $type,$required=false
*/

$this-> _addField ('shopId', 			'Identifiant de la boutique', 								null,								'String',true);
$this-> _addField ('transactionId', 	'Identifiant de transaction',								null,								'String',true);
$this-> _addField ('orderId',			'Rfrence de la commande',									null,								'String',true);
$this-> _addField ('cardNumber',		'Numro de carte',											null,								'String',true);
$this-> _addField ('orderInfo',			'Description libre de la commande',							null,								'String');
$this-> _addField ('orderInfo2',		'Description libre de la commande',							null,								'String'); 
$this-> _addField ('orderInfo3',		'Description libre de la commande',							null,								'String');
$this-> _addField ('customerId',		'Code client',												null,								'String');
$this-> _addField ('customerTitle',		'Civilit',													null,								'String');
$this-> _addField ('customerName',		'Nom client',												null,								'String');
$this-> _addField ('customerPhone',		'Tlphone client',											null,								'String');
$this-> _addField ('customerMail',		'Mail client',												null,								'String');
$this-> _addField ('customerAddress',	'Adresse client',											null,								'String');
$this-> _addField ('customerZipCode',	'Code postal client',										null,								'String');
$this-> _addField ('customerCity',		'Ville client',												null,								'String');
$this-> _addField ('customerCountry',	'Pays client',												null,								'String');
$this-> _addField ('customerIP',		'Adresse IP',												null,								'String');
$this-> _addField ('eci',				'ECI',														null,								'String');
$this-> _addField ('xid',				'XID',														null,								'String');
$this-> _addField ('cavv',				'CAVV',														null,								'String');
$this-> _addField ('comment',			'Commentaire  libre ',									null,								'String');
$this-> _addField ('cvv',				'Cryptogramme visuel',										null,								'String');
$this-> _addField ('subReference',		null,														'Ne pas renseigner',				'String');
$this-> _addField ('contractNumber',	'Numro de contrat commerant',								'Ne pas renseigner  vide',			'String');
$this-> _addField ('customerLanguage',	'Langue client',											'Code ISO 639-1, sur 2 caractres',	'String');
$this-> _addField ('brand',				'Brand de la carte ',										'"VISA" ou "MASTERCARD"',			'String',true);
$this-> _addField ('ctxMode',			'Contexte de sollicitation',								'"TEST" ou "PRODUCTION")',			'String',true);
$this-> _addField ('cardNetwork',		'Rseau de carte ',											'AMEX", "CB", "MASTERCARD", "VISA", "MAESTRO", "E-CARTEBLEUE','String',true);
$this-> _addField ('enrolled',			'Statut enrlement porteur ',								'"Y" : Enrl'."<br/>". '"N" : Non enrl'."<br/>". '"U" : Inconnu','String');
$this-> _addField ('paymentMethod',		'Source du paiement' ,										'"EC" : E-Commerce' ."<br/>". '"BO" : Backoffice' ."<br/>". '"MOTO" : mail ou tlphone' ."<br/>". '"CC" : centre dappel' ."<br/>". '"OTHER" : autres' ,'String',true);
$this-> _addField ('authStatus',		'Statut authentification ',									'"Y" : Authentifi 3DS'."<br/>". '"N" : Erreur Authentification'."<br/>". '"U" : Authentification impossible'."<br/>". '"A" : Essai dauthentification','String');
$this-> _addField ('cavvAlgorithm',		'Algorithme CAVV ',											'"0" : HMAC'."<br/>". '"1" : CVV'."<br/>". '"2" : CVV_ATN'."<br/>". '"3" :  Mastercard SPA','String');
$this-> _addField ('amount',			'Montant de la transaction',								'en plus petite unit montaire','Long',true);
$this-> _addField ('devise',			'Devise',													'Code monnaie ISO 4217' ."<br/>". 'Euro : 978',	'int',true);
$this-> _addField ('sequenceNb', 		'Numro de squence de la transaction', 					null,											'int',true);
$this-> _addField ('subPaymentType',	null,														'Ne pas renseigner',							'int');
$this-> _addField ('subPaymentNumber',	null,														'Ne pas renseigner',							'int');
$this-> _addField ('optionCode',	null,														'Numro parcelles',							'String');
$this-> _addField ('validationMode',	'Mode de validation',										'0 = Automatique' ."<br/>". ' 1 = Manuelle',	'int');
$this-> _addField ('customerSendEmail',	'Envoi e-mail client souhait',								'"0" : Non'."<br/>". '"1" : Oui','bool');
$this-> _addFieldThreeDS ('threeDsResult',		null,														'Ne pas renseigner', 'array');
$this-> _addField ('autorisationNb');
$this-> _addField ('newTransactionId');
$this-> _addField ('cardType');
$this-> _addField ('errorCode');
$this-> _addField ('extendedErrorCode');
$this-> _addField ('transactionStatus');
$this-> _addField ('initialAmount');
$this-> _addField ('cvAmount');
$this-> _addField ('cvDevise');
$this-> _addField ('type');
$this-> _addField ('multiplePaiement');
$this-> _addField ('cardCountry');
$this-> _addField ('transactionCondition');
$this-> _addField ('vadsEnrolled');
$this-> _addField ('vadsStatus');
$this-> _addField ('vadsECI');
$this-> _addField ('vadsXID');
$this-> _addField ('vadsCAVVAlgorithm');
$this-> _addField ('vadsCAVV');
$this-> _addField ('vadsSignatureValid');
$this-> _addField ('directoryServer');
$this-> _addField ('authMode');
$this-> _addField ('markAmount');
$this-> _addField ('markDevise');
$this-> _addField ('markNb');
$this-> _addField ('markResult');
$this-> _addField ('markCVV2_CVC2');
$this-> _addField ('authAmount');
$this-> _addField ('authDevise');
$this-> _addField ('authNb');
$this-> _addField ('authResult');
$this-> _addField ('authCVV2_CVC2');
$this-> _addField ('warrantlyResult');
$this-> _addField ('captureNumber');
$this-> _addField ('rapprochementStatut');
$this-> _addField ('refoundAmount');
$this-> _addField ('refundDevise');
$this-> _addField ('litige');
$this-> _addField ('timestamp');


/* Declarao dos objetos do tipo 'Date' 
$name, $label=null, $description=null, $type='Date',$required=false, $value=null
*/

$this->_addFieldDate ('transmissionDate',	'Date de transaction');
$this->_addFieldDate ('presentationDate',	'Date de remise demande');
$this->_addFieldDate ('cardExpirationDate',	'Date expiration de la carte');
$this->_addFieldDate ('captureDate');
$this->_addFieldDate ('markDate');
$this->_addFieldDate ('authDate');
$this->_addFieldDate ('autorisationDate');
$this->_addFieldDate ('remiseDate');

/**************************************************************************************************
Lista dos parametros obrigatrios para o calculo da assinatura do mtodo 'webservices Standard' 
definido pelo wsdl: https://secure.payzen.com.br/vads-ws/v3?wsdl				  
**************************************************************************************************/
//Lista dos parametros da funo create
$this->create = array($this->shopId, $this->transmissionDate, $this->transactionId, $this->paymentMethod, $this->orderId, $this->orderInfo, $this->orderInfo2, $this->orderInfo3,$this->amount,$this->devise, $this->presentationDate, $this->validationMode, $this->cardNumber, $this->cardNetwork, $this->cardExpirationDate, $this->cvv, $this->contractNumber, $this->threeDsResult, $this->subPaymentType, $this->subReference, $this->subPaymentNumber,$this->customerId,$this->customerTitle,$this->customerName, $this->customerPhone, $this->customerMail, $this->customerAddress, $this->customerZipCode, $this->customerCity, $this->customerCountry,$this->customerLanguage, $this->customerIP, $this->customerSendEmail, $this->ctxMode, $this->comment, $this->optionCode
		);

//Lista dos parametros da funo getInfo
$this->getInfo = array ($this-> shopId, $this->transmissionDate, $this->transactionId , $this->sequenceNb, $this->ctxMode);

//Lista dos parametros da funon cancel
$this->cancel= array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->comment);

//Lista dos parametros da funo validate
$this->validate = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->comment);

//Lista dos parametros da funo force
$this->force = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->autorisationNb,
			$this->autorisationDate,$this->comment
			);
	
//Lista dos parametros da funo modify
$this->modify = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->amount,$this->devise,
			$this->remiseDate,$this->comment
			);

//Lista dos parametros da funo modifyAndValidate
$this->modifyAndValidate = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->amount,$this->devise,
			$this->remiseDate,$this->comment
			);
			
//Lista dos parametros da funo refund
$this->refund = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->newTransactionId,
			$this->amount,$this->devise,$this->presentationDate,$this->validationMode,$this->comment
			);
	
//Lista dos parametros da funo duplicate
$this->duplicate = array ($this->shopId,$this->transmissionDate,$this->transactionId,$this->sequenceNb,$this->ctxMode,$this->orderId,
			$this->orderInfo,$this->orderInfo2,$this->orderInfo3,$this->amount,$this->devise,$this->newTransactionId,$this->presentationDate,
			$this->validationMode,$this->comment
			);

//Lista dos parametros da funo TransactionInfo 
$this->transactionInfo = array ($this->errorCode, $this->extendedErrorCode, $this->transactionStatus, $this->shopId, $this->paymentMethod, 
			$this->contractNumber, $this->orderId, $this->orderInfo, $this->orderInfo2,$this->orderInfo3, $this->transmissionDate, $this->transactionId,
			$this->sequenceNb, $this->amount, $this->initialAmount, $this->devise, $this->cvAmount, $this->cvDevise,$this->presentationDate, $this->type,
			$this->multiplePaiement, $this->ctxMode, $this->cardNumber, $this->cardNetwork, $this->cardType, $this->cardCountry, $this->cardExpirationDate,
			$this->customerId, $this->customerTitle, $this->customerName,$this->customerPhone, $this->customerMail, $this->customerAddress, 
			$this->customerZipCode, $this->customerCity,$this->customerCountry, $this->customerLanguage, $this->customerIP, $this->transactionCondition,
			$this->vadsEnrolled, $this->vadsStatus, $this->vadsECI, $this->vadsXID,$this->vadsCAVVAlgorithm, $this->vadsCAVV, $this->vadsSignatureValid, 
			$this->directoryServer,$this->authMode, $this->markAmount, $this->markDevise, $this->markDate, $this->markNb,$this->markResult, $this->markCVV2_CVC2,
			$this->authAmount, $this->authDevise, $this->authDate, $this->authNb, $this->authResult,$this->authCVV2_CVC2, $this->warrantlyResult,
			$this->captureDate, $this->captureNumber, $this->rapprochementStatut, $this->refoundAmount, $this->refundDevise, $this->litige, $this->timestamp
			);

//Lista dos parametros da funo standardResponse
$this->standardResponse = array ($this->errorCode, $this->extendedErrorCode, $this->transactionStatus, $this->timestamp);

//Lista dos parametros da funo threeDsResult
$this->threeDsResult =array ($this->brand, $this->enrolled, $this->authStatus, $this->eci, $this->xid, $this->cavv, $this->cavvAlgorithm);		
}
	
	
/***************************************************************************************************
Fontion getSignature:
@param 	$data:	lista dos parametros a assinar
@param 	$methode: 	noms do mtodo utilizado: ex create ou getInfo etc..
@return 	$wsSignature:	SHA1 da string construida a partir dos parmetros enviados

Exemplo chamda desta funo:
		
	$wsSignature= $obj-> getSignature($data,$methode_name);

	$obj:	objet de la classe WS_API
	$data:	tabela dos parmetros a assinar
	$methode_name : variveis de tipo string, definidos no "getInfo" para este exemplos

ARENO: 
			Todos os campos do tipo 'Date' devem ser expresso no formato W3C
			O objeto $sign deve conter o certificado definido no atributo 'key'
			Esta funo s funciona com web services Standards V3
***************************************************************************************************/
function getSignature ($data,$methode){	
	
		$raw_sign =	'';
		$list=$this->$methode;
			foreach($list as $field) {
							
				
				//recuperao do valor, string vzia de o parametro no for informado
				$name=$field->name;
				
				$value = array_key_exists($name, $data)
				? $data[$name]
				: null;
				
				$field->setValue($value);
								if($name == 'optionCode') continue;

				$raw_sign .= $field->getSignatureValue() . '+';
				
			}
		
		$raw_sign .=$this->key;
		//echo $raw_sign;		
		$wsSignature = sha1($raw_sign);
		return $wsSignature;
	
}	
/***************************************************************************************************
Fontion formatReq
Parse l'ensemble des paramtres attendus, remplace par null la valeur d'un champ si celui ci n'est pas envoy.

*@param 	$data		:	lista dos parmetros para enviaro ao soap
*@param 	$methode	: 	nome do mtod utilizado: ex create, getInfo etc..
*@return 	$wsSignature:	sha1 da string construida a partir dos parmetros enviados

****************************************************************************************************/
function formatReq($data,$methode){
	$result = array();

	//Tabela dos parmetros a serem enviados  soap
	$list=$this->$methode;

	foreach($list as $field) {
	//reperao de um valor, null se o parmetro no for definido
		$name=$field->name;
		$value= array_key_exists($name, $data)
		?$data[$name]
		: null;
		
		$field->setValue($value);		
		$formatted_value = $field->getValue();
		
		//Adicionando-se  tabela de parmetros soap
		if ($formatted_value!==null){
			$result[$name] = $formatted_value;
		}
	}
	
	return $result;

	
	
}
/*****************************************************************************************************
Fonction getErrorCode:
Exibe o texto do cdigo de erro 'errorCode' retornado pela plataforma de pagamento aps uma consulta WS
@param : errorCode : Numero do cdigo de erro

@return: $errorLabel : Definio do cdigo de erro		
*****************************************************************************************************/
function getErrorCode ($errorCode) {
		

	$errorTab= array(

	"0" => "Ao finalizada com sucesso",
	"1" => "Ao no autorizada",
	"2" => "Transao no encontrada",
	"4" => "TransactionId/Sequence/TransmissionDate  j existente",
	"5" => "Assinatura invalida",
	"10" => "Valor invalido",
	"11" => "Moeda invalida",
	"12" => "Tipo de carto descinhecido",
	"13" => "Data expirao do carto incorreto",
	"14" => "CVV obrigatrio",
	"15" => "Contrato desconhecido",
	"16" => "Nmero do carto de crdito invalido (longeur, luhn, )",
	"50" => "Parmetro shopId invalido",
	"51" => "Parmetro transmissionDate invalido",
	"52" => "Parmetro transactionId invalido",
	"53" => "Parmetro ctxMode invalido",
	"50" => "Parmetro shopId invalido",
	"51" => "Parmetro transmissionDate invalido",
	"52" => "Parmetro transactionId invalido",
	"53" => "Parmetro ctxMode invalido",
	"54" => "Parmetro comment invalido",
	"57" => "Parmetro presentationDate invalido",
	"58" => "Parmetro newTransactionId invalido",
	"59" => "Parmetro validationMode invalido",
	"60" => "Parmetro orderId invalido",
	"61" => "Parmetro orderInfo invalido",
	"62" => "Parmetro orderInfo2 invalido",
	"63" => "Parmetro orderInfo3 invalido",
	"64" => "Parmetro PaymentMethod invalido",
	"65" => "Parmetro cardNetwork invalido",
	"66" => "Parmetro contractNumber invalido",
	"67" => "Parmetro customerId invalido",
	"68" => "Parmetro customerTitle invalido",
	"69" => "Parmetro customerName invalido",
	"70" => "Parmetro customerPhone invalido",
	"71" => "Parmetro customerMail invalido",
	"72" => "Parmetro customerAddress invalido",
	"73" => "Parmetro customerZipCode invalido",
	"74" => "Parmetro customerCity invalido",
	"75" => "Parmetro customerCountry invalido",
	"76" => "Parmetro customerLanguage invalido",
	"77" => "Parmetro customerIP invalido",
	"78" => "Parmetro customerSendMail invalido",
	"99" => "Erro desconhecido",
	);

	if(array_key_exists($errorCode,$errorTab)){
		$errorLabel = $errorTab[$errorCode];
		return $errorLabel;
	}
}
/*****************************************************************************************************
Fonction getTypeResponse
Fornece o tipo de resposta para cada mtodo tal como definido na wsdl
@param: $methode_name o nome do mtodo

@return: $type: O tipo de resposta
*****************************************************************************************************/
Function getTypeResponse($methode_name){
	
	if ($methode_name=="refund" || $methode_name=="getInfo" || $methode_name == "duplicate" || $methode_name == "create" )
	{
	$type= "transactionInfo";
	}
	else{ 
	$type="standardResponse"; 
	}
	return($type);
}	

/*****************************************************************************************************
Fonction getResponse:
Permite calcular a assinatura da resposta da plataforma
@param: $methode_name: nome do mtodo
@param: $answer: objeto contendo o retorno da resposta da chamada do webservice

@return: $response: tabela contendo dois valores:
	$result: boolean (true se a comprao da assintura for valida, false se for o contrrio)
	$message: messagem indicando o resultado da comparao das assinaturas
*****************************************************************************************************/
Function getResponse($methode_name, $answer){

	$response_type = $this->getTypeResponse($methode_name);
	
	$param = array();
	$param = get_object_vars($answer);

	// calcula assinatura 
	$wsSigncalc = $this-> getSignature($param,$response_type);
	
	
	// comparao das assinaturas	
	if ($answer->signature != $wsSigncalc){
		$result= '0';
		$message="Analise do resposta: Resposta invalida. <br/>";
	}
	else
		{
		$result='1';
		$message="Analise do resposta: Assinatura vlida. <br/>";

		}	
		
	$response= array ();
		$response['result']=$result;
		$response['message']=$message;	
	return $response;	
}

/*****************************************************************************************************
Fonction create:
Pedido de criao de pagamento
@param: tabela dos parmetros do tipo createPaiementInfo 
@return: $res: objeto do tipo transactionInfo
*****************************************************************************************************/

function create($param){
$methode_name="create";
$wsSignature= $this-> getSignature($param,$methode_name);
//	array_push($param, ['optionCode','3']);
//   $param['optionCode']='3';
	$param_soap= array();
	$param_soap['createInfo'] = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;


$res = $this->client-> __soapCall($methode_name,$param_soap);

return $res;
}

/*****************************************************************************************************
Fonction getInfo:
Esta funo permite consultar uma transao para obter seus diferentes atributos
@param: tabela dos parmetros contendo os seguintes campos:
	shopId
	transmissionDate
	transactionId
	sequenceNb
	ctxMode
 
@return: $res: objeto do tipo transactionInfo
*****************************************************************************************************/

function getInfo($param){
$methode_name="getInfo";
$wsSignature= $this-> getSignature($param,$methode_name);
	
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;

$res = $this->client-> __soapCall($methode_name,$param_soap);
		
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;

}

/*****************************************************************************************************
Fonction modify:
Esta funo permite modificar o valor de uma transao (para baixo) ou mudar a data de captura.
As transaes que permitem alteraes devem possuir um dos seguintes status:
	A validar
	A validar e autorizar
	Pendente
	Pendente autorizao
	Pendente captura

@param: tabela de parametros contem o seguintes campos:
	shopId
	transmissionDate
	transactionId
	sequenceNb
	ctxMode
	amount
	devise
	remiseDate
	comment

@return: $res: objeto do tipo standardResponse
*****************************************************************************************************/
function modify($param){
$methode_name="modify";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;

}
/*****************************************************************************************************
Fonction validate:
Esta funo permite modificar o valor de uma transao (para baixo) ou mudar a data de captura.
As transaes que permitem alteraes devem possuir um dos seguintes status:
	A validar
	A validar e autorizar
	Pendente
	Pendente autorizao
	Pendente captura
@param:tabela de parametros contem o seguintes campos:
	shopId
	transmissionDate
	transactionId
	sequenceNb
	ctxMode
	amount
	devise
	remiseDate
	comment

@return: $res: objeto do tipo standardResponse
*****************************************************************************************************/
function modifyAndValidate($param){
$methode_name="modifyAndValidate";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}
/*****************************************************************************************************
Fonction validate:
Esta funo  usado para permitir a captura de uma transao. As transaes que permitem este tipo de chamada devem possuir um dos seguintes status:
	A validar
	A validar e autorizar
@param:tabela de parmetros contem o seguintes campos:
	shopId
	transmissionDate
	transactionId
	sequenceNb
	ctxMode
	comment

@return: $res: objeto do tipo standardResponse
*****************************************************************************************************/
function validate ($param) {
$methode_name="validate";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}
/*****************************************************************************************************
Fonction cancel:
Esta funo permite cancelar uma transao, no haver captura, ao permitida para transaes com um dos status abaixo:
	A validar
	A validar e autorizar
	Pendente
	Pendente autorizao
	Pendete captura

@param: tabela de parmetros contem o seguintes campos:
	shopId
	transmissionDate
	transactionId
	sequenceNb
	ctxMode
	comment

@return: $res: objeto do tipo standardResponse
*****************************************************************************************************/
function cancel ($param) {
$methode_name="cancel";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}
function force ($param) {
$methode_name="force";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_modifyAndValidate= array();
	$param_modifyAndValidate = $this-> formatReq($param,$methode_name);
	$param_modifyAndValidate['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_modifyAndValidate);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}
function duplicate ($param) {
$methode_name="duplicate";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}
function refund ($param) {
$methode_name="refund";
$wsSignature= $this-> getSignature($param,$methode_name);
	$param_soap= array();
	$param_soap = $this-> formatReq($param,$methode_name);
	$param_soap['wsSignature']= $wsSignature;
$res = $this->client-> __soapCall($methode_name,$param_soap);
//print_r($this->getResponse($methode_name,$res));		
//print_r($this->getErrorCode ($res->errorCode));
//print_r($res);
return $res;
}




}	
	
?>



