﻿<?php

/***************************************************************************************************
Webservices V3 - pack version 03- Metodo criar

Este programa utiliza as funções contidas no arquivo WStoolsV3 fornecido no pacote Webservice Standard

Este programa permite chamar o metodo criar definido no wsdl em:  https://systempay.cyberpluspaiement.com/vads-ws/v3?wsdl'.


Este método cria uma pagamento
•	Para validar				-> status => 1
•	Para validar e autorizar	-> status => 3
•	Espera						-> status => 10
•	Espera automatico			-> status => 5
•	Espera de captura			-> status => 4


PARAMETROS DE ENTRADA DO MÉTODO

•	$params é uma tabela de parâmetros:

	- 	shopId => Código de identificação da loja, esta informação você obtem em seu backoffice do PayZEN em Configuração >> Lojas >> Sua loja >> Aba Configuração.'

	-	transmissionDate => Data da apresentação da transação definido na criação do pagamento.
		É obrigatório utilizar o formato DD-MM-AAAA para a data
	
	-   transactionId => Identificação da transação definido na criação do pagamento. Este código será a identificação nem sua ferramenta de gestão do PayZEN, o backoffice.
			
	-	paymentMethod => Valor obrigatório EC para ecommerce
	
	- 	orderId =>				Código do pedido
	
	- 	orderInfo => 			Descrição livre do pedido		
	- 	orderInfo2 => 			Descrição livre do pedido		
	- 	orderInfo3 => 			Descrição livre do pedido		
	- 	amount => 				Valor da transação sem nenhuma formatação de milhar ou casa decimal, ex R$ 10,00 => 1000		
	-	devise => 				Moéda da transação, usar 986 para Reais,  codigo-moeda ISO 4217		
	-	presentationDate =>		Data da captura obrigatoriamento informado como formato DD-MM-AAAA	
	-	validationMode => 		Usar 0 para captura automática ou 1 para captura manual 		
	- 	cardNumber => 			Número do cartão		
	-	cardNetwork => 			Rede de adquirente( CIELO_VISA, CIELO_MASTERCARD, REDECARD_VISA, etc ...) 		
	-	cardExpirationDate =>	Data de validade do cartão, obrigatório usar o formato DD-MM-AAAA
	-	cvv =>					Criptograma visual	
	-	contractNumber =>  		Número de contrato meio pagamento		
	-	threeDsResult =>		Deixar em branco	
	- 	subPaymentType =>		Deixar em branco	
	-	subReference =>			Deixar em branco
	-	subPaymentNumber => 	Deixar em branco		
	-	customerId =>			Codigo cliente
	-	customerTitle => 		Tratamento(Sr, Sra, Srta)	
	- 	customerName =>			Nome cliente
	-	customerPhone =>		Telefone	
	-	customerMail =>			E-mail
	-	customerAddress =>		Endereço cliente	
	-	customerZipCode =>		Codigo Postal - CEP	
	-	customerCity =>			Cidade
	-	customerState =>		Estado
	-	customerCountry =>		País	
	-	customerLanguage =>		Idioma	iso 639-1 2 caractéres.
	-	customerIP =>			Endereço IP do cliente
	-	customerSendEmail =>	Não funcional no momento		
	
	-	ctxMode => Este parâmetro define o ambiente de teste ou produção. Para o ambiente de teste utilize o valor TEST e para o de produção utilize o valor PRODUCTION.
		
	-	comment => Utilizado para eventual comentário que será registrado no backoffice do PayZEN
	
	
	

• $key corresponde ao certificado . Este valor é diferente para o ambiente de produto e de testes .
Você encontra o certificado no backoffice do PayZEN em Configuração >> Lojas >> Sua loja >> Aba Certificados.

***************************************************************************************************/
$now = date('His');

// Declaração dos parâmetros de entrada no método criar
$param=array();
$param['shopId']='94956185';
$param['transmissionDate']=date('His');
$param['transactionId']=$now;
$param['paymentMethod']='EC';
$param['orderId']='commande'. $now;
$param['orderInfo']='Transacao de teste';
$param['orderInfo2']=$now;
$param['orderInfo3']='';
$param['amount']='120';
$param['devise']='986';
$param['presentationDate']=date('His');
$param['validationMode']='1';
$param['cardNumber']='4970100000000007';
$param['cardNetwork']='REDECARD_VISA';
$param['cardExpirationDate']='01-02-2015';
$param['cvv']='225';
$param['threeDsResult']=null;
$param['subPaymentType']=null;
$param['subReference']=null;
$param['subPaymentNumber']=null;
$param['customerId']='CLIENT01';
$param['customerTitle']='Sra';
$param['customerName']='Reinaldo Santos';
$param['customerPhone']='0123456789';
$param['customerMail']='email@email.com.br';
$param['customerAddress']='Rua do endereço';
$param['customerZipCode']='00000000';
$param['customerCity']='Sao Paulo';
$param['customerCountry']='Brasil';
$param['customerLanguage']='pt';
$param['customerIP']='0.0.0.0';
$param['customerSendEmail']=null;
$param['ctxMode']='TEST';
$param['comment']='Test webservice';
$param['optionCode']='1';

require_once './classes/wsToolV3.php';
//Declaração do objeto
$WS= new WS_API();

// Déclaração do certificado, atributo de objeto WS


$WS->key='9874548989598030';  // Atenção: Este parametro possui valores diferentes para o ambiente de TESTE e PRODUÇÃO - CHAVE DE TESTE

// Chamada do método e retorno da respota.

$response=$WS->create($param); // Esta função da classe WS_API retorna um objeto do tipo transaction Info

// Analise da assinatura obtido no retorno.
$control_sign=array();
$control_sign=$WS->getResponse('create',$response);

	if ($control_sign['result']=='1')
		{
			
			//Se a assinatura for válida, você pode considerar que os dados retornados são seguros.
		
			// Exibição da resposta
			echo $control_sign['message'].'</br>';
			echo 'Você pode considerar os dados técnicos listados abaixo como seguro </br>';
			echo '<div style="border:1px solid black;;width:400px;margin-left:auto;margin-right:auto;margin-top:25px"></br>';
			echo 'ELEMENTOS TÉCNICOS RETORNADOS';
			echo '</br></br>';
			print_r ('<table ');
				foreach ($response as $name => $value)
				{
				echo ('<tr><td style="font-size:12px;text-align:left">'.$name .'</td><td style="font-size:12px;text-align:left">'.$value.'</td></tr>');
    			}
			print_r('</table>');
			echo '</div>';
			echo '</br></br>';
		
		}
	else
		{
			//Se a assinatura não for válida, você pode considerar que os dados retornados não são seguros, risco de fraude.
		
			// Exibição da resposta
			echo $control_sign['message'].'</br>';
			echo 'Os dados listados abaixo não são seguro - Risco de fraude</br>';
			echo '<div style="border:1px solid black;;width:400px;margin-left:auto;margin-right:auto;margin-top:25px"></br>';
			echo 'ELEMENTOS TÉCNICOS RETORNADOS';
			echo '</br></br>';
			print_r ('<table ');
				foreach ($response as $name => $value)
				{
				echo ('<tr><td style="font-size:12px;text-align:left">'.$name .'</td><td style="font-size:12px;text-align:left">'.$value.'</td></tr>');
    			}
			print_r('</table>');
			echo '</div>';
			echo '</br></br>';
	
		}




?>